function varargout = aperture(varargin)
% APERTURE M-file for aperture.fig
%      APERTURE, by itself, creates a new APERTURE or raises the existing
%      singleton*.
%
%      H = APERTURE returns the handle to a new APERTURE or the handle to
%      the existing singleton*.
%
%      APERTURE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in APERTURE.M with the given input arguments.
%
%      APERTURE('Property','Value',...) creates a new APERTURE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before aperture_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to aperture_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help aperture

% Last Modified by GUIDE v2.5 03-Feb-2005 21:36:11

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @aperture_OpeningFcn, ...
                   'gui_OutputFcn',  @aperture_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before aperture is made visible.
function aperture_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to aperture (see VARARGIN)

global gT gSquare gMask

% Choose default command line output for aperture
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% This sets up the initial plot - only do when we are invisible
% so window can get raised using aperture.
if strcmp(get(hObject,'Visible'),'off')
    gSquare = square;
    gMask = mask(size(gSquare), 'center');
    show(gSquare, gMask);
    drawnow
    set(hObject, 'CloseRequestFcn', @closeGui);
    set(handles.centerbutton, 'Value', 1);
    set(handles.sidebutton, 'Value', 0);
    set(handles.cornerbutton, 'Value', 0);
    guidata(hObject, handles);
    gT = timer('TimerFcn', @timerCallback, ...
        'Period', 0.5, 'ExecutionMode', 'fixedRate', 'BusyMode','drop', ...
        'StartDelay', 2);
    start(gT);
end

% UIWAIT makes aperture wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = aperture_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
axes(handles.axes1);
cla;

popup_sel_index = get(handles.popupmenu1, 'Value');
switch popup_sel_index
    case 1
end


% --------------------------------------------------------------------
function FileMenu_Callback(hObject, eventdata, handles)
% hObject    handle to FileMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function OpenMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to OpenMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
file = uigetfile('*.fig');
if ~isequal(file, 0)
    open(file);
end

% --------------------------------------------------------------------
function PrintMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to PrintMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
printdlg(handles.figure1)

% --------------------------------------------------------------------
function CloseMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
                     ['Close ' get(handles.figure1,'Name') '...'],...
                     'Yes','No','Yes');

global gT
if strcmp(selection,'No')
    return;
end

stop(gT)
delete(gT)
delete(handles.figure1)


% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1


% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

set(hObject, 'String', {'Square'});

% --- Executes on button press in centerbutton.
function centerbutton_Callback(hObject, eventdata, handles)
% hObject    handle to centerbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handleButton(hObject, handles, 'center');


% --- Executes on button press in sidebutton.
function sidebutton_Callback(hObject, eventdata, handles)
% hObject    handle to sidebutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of sidebutton
handleButton(hObject, handles, 'side');


% --- Executes on button press in cornerbutton.
function cornerbutton_Callback(hObject, eventdata, handles)
% hObject    handle to cornerbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of cornerbutton
handleButton(hObject, handles, 'corner');

function handleButton(hObject, handles, where)

global gSquare gMask

if (get(hObject,'Value') == get(hObject,'Max'))
    gMask = mask(size(gSquare), where);
    set(handles.centerbutton, 'Value', 0);
    set(handles.sidebutton, 'Value', 0);
    set(handles.cornerbutton, 'Value', 0);
    set(handles.nomask, 'Value', 0);
    set(gcbo, 'Value', 1);
    guidata(hObject, handles);
end

function show(sq, mask)

figure(1)
imagesc(sq .* mask);
colormap gray
axis off

function timerCallback(hObject, event)

global gSquare gMask

gSquare = square;
show(gSquare, gMask);


% --- Executes on button press in nomask.
function nomask_Callback(hObject, eventdata, handles)
% hObject    handle to nomask (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of nomask
handleButton(hObject, handles, 'none');

function closeGui(varargin)

global gT

stop(gT)
delete(gT)
closereq;