function m = mask(sze, location)

if strcmp(location, 'none')
    m = ones(sze);
else
    n = floor(sze(1)/6);
    m = zeros(sze);

    switch location
        case 'center'
            origin = floor((sze - n)/2);
        case 'side'
            origin(1) = floor((sze(1) - n) / 2);
            origin(2) = floor(sze(1) / 4 + sze(2) / 2 - n / 2);
        case 'corner'
            origin(1) = floor(sze(1) / 4 + sze(1) / 2 - n / 2);
            origin(2) = floor(sze(1) / 4 + sze(2) / 2 - n / 2);
        otherwise
            error(sprintf('Unknown location specifier %s', location))
    end

    m(origin(1) + (1:n), origin(2) + (1:n)) = 1;
end